data BW = Black
	    | White
        deriving Eq
	
data Color > BW = 
        Red 
        deriving Eq

struct Point =
	xpos :: Int
	ypos :: Int

struct CPoint < Point =
	color :: Color

pt      = {xpos = 0; ypos = 1}
cpt     = {xpos = 0; ypos = 1; color = Red}

addcolor p = {xpos = p.xpos; ypos = p.ypos; color = Black}

unif1 x Black = x
unif1 x White = Red

unif2 x@Black = x
unif2 White   = Red

unif3 x = if x.color == Red then x else pt

f1 p = if p.xpos == 0 then pt else p

f2 p = if p.xpos == 0 then cpt else p

twice f x = f (f x)

justpoint = twice addcolor pt
