data Color = Red
	   | Green
           | Blue
           deriving Eq

struct Point =
	xpos :: Int
	ypos :: Int

struct CPoint < Point =
	color :: Color

struct Eq' a =
	eq :: a -> a -> Bool

struct Ord' a < Eq' a =
	less :: a -> a -> Bool

elem0 dict x []     = False
elem0 dict x (y:ys) = if dict.eq x y then True else elem0 dict x ys

elem1 dict x []     = False
elem1 dict x (y:ys) = if dict.eq x y then y.xpos == 0 else elem1 dict x ys

elem2 dict x []     = x.color == Red
elem2 dict x (y:ys) = if dict.eq x y then y.xpos == 0 else elem2 dict x ys

elem3 x []     dict = x.color == Red
elem3 x (y:ys) dict = if dict.eq x y then y.xpos == 0 else elem3 x ys dict

elem4 dict x xs = case xs of
                     []   -> x.color == Red
                     y:ys -> if dict.eq x y then y.xpos == 0 else elem4 dict x ys

elem4a x xs = case xs of
                     []   -> \dict -> x.color == Red
                     y:ys -> \dict -> if dict.eq x y then y.xpos == 0 else elem4a x ys dict

elem5 dict x xs = case (x,xs) of
                     (x,[])   -> x.color == Red
                     (x,y:ys) -> if dict.eq x y then y.xpos == 0 else elem5 dict x ys

elem6 dict x []     = dict.less x x
elem6 dict x (y:ys) = if dict.eq x y then y.xpos == 0 else elem6 dict x ys

adict1 = { a `eq` b   = False }
           
adict2 = { a `eq` b   = False;
           a `less` b = True }

pdict1 = { a `eq` b   = a.xpos == b.xpos }

pdict2 = { eq         = pdict1.eq;
           a `less` b = a.ypos < b.ypos }

cpdict1 = { a `eq` b  = a.color == Red}
           
cpdict2 = { a `eq` b   = a.xpos == 0;
	    a `less` b = if a.color == Red then a.ypos < b.ypos else False }


pt  = {xpos = 0; ypos = 1}
cpt = {xpos = 0; ypos = 1; color = Red}

min0 p q = if p.xpos < q.xpos then p else q

loss1 = min0 cpt cpt

min' dict p q = if dict.less p q then p else q

cpt1 = min' cpdict2 cpt cpt      -- CPoint

cpt2 = min' pdict2 cpt cpt       -- CPoint

cptf = min' pdict2 cpt           -- CPoint -> CPoint

pt1  = min' pdict2 cpt pt        -- Point

ptf  = min' pdict2               -- Point -> Point -> Point


loss2 = let minp = min' pdict2 in minp cpt cpt

-- instead = letm minp = min' pdict2 in minp cpt cpt
